'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _regeneratorRuntime = _interopDefault(require('babel-runtime/regenerator'));
var _asyncToGenerator = _interopDefault(require('babel-runtime/helpers/asyncToGenerator'));
var rollupPluginutils = require('rollup-pluginutils');
var sourceMapResolve = require('source-map-resolve');
var fs = require('fs');
var _Promise = _interopDefault(require('babel-runtime/core-js/promise'));

/* eslint-disable import/prefer-default-export */
function promisify(nodeFn) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new _Promise(function (resolve, reject) {
      nodeFn.apply(undefined, args.concat([function (error, result) {
        if (error) {
          reject(error);
        } else {
          resolve(result);
        }
      }]));
    });
  };
}

/* eslint-disable no-console */
var readFileAsync = promisify(fs.readFile);
var resolveSourceMapAsync = promisify(sourceMapResolve.resolve);

function sourcemaps() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var include = _ref.include;
  var exclude = _ref.exclude;

  var filter = rollupPluginutils.createFilter(include, exclude);

  return {
    name: 'sourcemaps',

    load: function load(id) {
      var _this = this;

      return _asyncToGenerator(_regeneratorRuntime.mark(function _callee() {
        var code, sourceMap, _sourceMap, map, sourcesContent;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (filter(id)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt('return', null);

              case 2:
                code = void 0;
                _context.prev = 3;
                _context.next = 6;
                return readFileAsync(id, 'utf8');

              case 6:
                code = _context.sent;
                _context.next = 12;
                break;

              case 9:
                _context.prev = 9;
                _context.t0 = _context['catch'](3);
                return _context.abrupt('return', null);

              case 12:
                sourceMap = void 0;
                _context.prev = 13;
                _context.next = 16;
                return resolveSourceMapAsync(code, id, fs.readFile);

              case 16:
                sourceMap = _context.sent;
                _context.next = 23;
                break;

              case 19:
                _context.prev = 19;
                _context.t1 = _context['catch'](13);

                console.error('rollup-plugin-sourcemaps: Failed resolving source map from ' + id + ': ' + _context.t1);
                return _context.abrupt('return', code);

              case 23:
                if (!(sourceMap === null)) {
                  _context.next = 25;
                  break;
                }

                return _context.abrupt('return', code);

              case 25:
                _sourceMap = sourceMap;
                map = _sourceMap.map;
                sourcesContent = _sourceMap.sourcesContent;


                map.sourcesContent = sourcesContent;

                return _context.abrupt('return', { code: code, map: map });

              case 30:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this, [[3, 9], [13, 19]]);
      }))();
    }
  };
}

module.exports = sourcemaps;
//# sourceMappingURL=rollup-plugin-sourcemaps.js.map
